import BusX
import Combine

extension MeetupId {
  final class Formatter: ObservableObject {
    let text = PassthroughSubject<String, Never>()
    var subscriptions = [AnyCancellable]()

    init(
      _ src: String,
      _ dst: String
    ) {
      Bus.receive(
        [src],
        { [weak self] _, v in self?.text.send(v) },
        sub: &subscriptions
      )

      Bus.send(
        dst,
        text
          .debounce(for: .seconds(0.2), scheduler: DispatchQueue.main)
          .compactMap(formatId)
          .eraseToAnyPublisher(),
        sub: &subscriptions
      )
    }
  }
}
